;SIDHACKER LOAD-ROUTINE
;----------------------
         *= $0880
START    SEI
         LDA #$37
         STA 1
         LDA #$31
         STA $0314
         LDA #$EA
         STA $0315
         LDA #$17
         STA $D018
         LDA #0
         STA $D011

         LDA #$24
         STA $0100 ;FILENAME IS $
         LDY #1
         STY $94   ;FILENAME LENGTH
         STY 4
         DEY
         STY $92   ;FORCE LOAD TO $F000

         LDA #$F0
         STA 3
CLRLOOP  LDA #0
         STA (2),Y
         INY
         BNE CLRLOOP
         INC 3
         LDA 3
         CMP #$FF
         BNE CLRLOOP

         JSR LOADING

         LDA #$1B
         STA $D011
         STA 2

         LDY #0
CLRLP2   LDA #$20
         STA $0400,Y
         STA $0500,Y
         STA $0600,Y
         STA $0700,Y
         LDA #$0C
         STA $D800,Y
         STA $D900,Y
         STA $DA00,Y
         STA $DB00,Y
         INY
         BNE CLRLP2

         SEI
         LDA #$35
         STA 1
         LDA #$F0
         STA 3
         LDA #$04
         STA 5
ROWCONV  LDX #$FF
         JSR ROWREAD
         INX
         LDA 3
         BEQ MEMEND
         JSR ROWREAD
         LDA 4
         CLC
         ADC #20
         STA 4
         LDA 5
         ADC #0
         STA 5
         CMP #$08
         BNE ROWCONV
MEMEND   LDA #$37
         STA 1
         LDY #23
         LDA #$20
ENDCLL   STA $07E8,Y
         DEY
         BPL ENDCLL

         LDA #0
         STA 4
         TAY
         LDA #$04
         STA 5
         JMP WRCRSR
;---------------------------------------
KYS     LDA #$80
         CMP $D012
         BNE *-3
         LDA #$7F
         STA $DC00
         LDA $DC01
         AND #2
         BNE nobk
         JMP TOPRG
nobk   LDA $DC01
         AND #$10
         BNE NOSPC
         JMP START
NOSPC    LDA #$FE
         STA $DC00
         LDA $DC01
         AND #2
         BNE NORET
         JMP LOADFILE
NORET    LDA $DC01
         AND #4
         BNE NORIGHT
         LDY #0
         LDA #$20
         STA (4),Y
         LDA #$BF
         STA $DC00
         LDA $DC01
         AND #$10
         BEQ LEFTER
         LDX #50
ENL      JSR DOWNER
         DEX
         BPL ENL
         JMP WRCRSR
LEFTER   LDA #0
         STA 4
         LDA #$04
         STA 5
         JMP WRCRSR
NORIGHT  LDA $DC01
         AND #$80
         BNE nky
         LDA 2
         BEQ PRESS1
         CMP #10
         BEQ PRESS2
         DEC 2
         JMP KYS
PRESS1   LDA #2
         STA 2
PRESS2   DEC 2
         LDA #$BF
         STA $DC00
         LDA $DC01
         AND #$10
         BEQ UP
DOWN     JSR DOWNER
         JMP WRCRSR

UP       LDA 4
         BNE UPP
         LDA 5
         CMP #$04
         BEQ KEYEND
UPP      LDA #$20
         STA (4),Y
         LDA 4
         SEC
         SBC #20
         STA 4
         BCS WRCRSR
         DEC 5

WRCRSR   LDA #$3E
         STA (4),Y

KEYEND
         JMP KYS

nky    LDA #10
         STA 2
         JMP KYS
;---------------------------------------
ROWREAD  LDY #0
LOOP3    LDA (2),Y
         CPX #0
         BMI NOWR
         STA (4),Y
NOWR     INY
         CPY #$20
         BNE ONEROW
         LDX #$F0
         JMP NOROW
ONEROW   CMP #$22
         BNE LOOP3
         LDA (2),Y
         BEQ LOOP3
NOROW    TYA
         CLC
         ADC 2
         STA 2
         BCC PAGE
         INC 3
PAGE     RTS
;---------------------------------------
LOADING  LDA #$00
         STA $A5   ;LOADADRESS LOW BYTE
         LDA #$F0
         STA $A6   ;LOADADRESS HI BYTE
         LDX #0
         LDY #1
         LDA $94
         JSR $FFBD ;SET FILENAME TO OPEN
         LDA #1
         LDX #8
         LDY $92
         JSR $FFBA ;OPEN DRIVE8 & FILE1
         LDA #0
         LDX $A5
         LDY $A6
         JSR $FFD5 ;SET LOADADDRESS
         LDA #8
         JSR $FFB4 ;LOAD FILE
         LDA #8
         JSR $FFAB ;CLOSE DRIVE8
         LDA #1
         JSR $FFC3 ;CLOSE FILE 1
         RTS
;---------------------------------------
LOADFILE LDY #1
         STY $92
READNAME LDA (4),Y
         CMP #$22
         BEQ NAMEOK
         STA $FF,Y
         INY
         CPY #$11
         BNE READNAME
NAMEOK   DEY
         STY $94

         LDY #0
         STY 2
         LDA #$0C
         STA 3
CLLLP    LDA #0
CLLP     STA (2),Y
         INY
         BNE CLLP
         INC 3
         LDA 3
         CMP #$D0
         BNE CLLLP

         LDA #0
         STA $D011
         JSR LOADING
TOPRG    SEI
         LDA #$35
         STA 1
         JMP $E000
;---------------------------------------
DOWNER   LDY #21
         LDA (4),Y
         LDY #0
         CMP #$20
         BEQ DOWEND
         LDA #$20
         STA (4),Y
         LDA 4
         CLC
         ADC #20
         STA 4
         BCC DOWEND
         INC 5
DOWEND   RTS

